﻿var oOptions = {
	aOptionList: [],
	saveselection: function (itemID, itemValue) {
		this.aOptionList[itemID] = itemValue;
	},
	getselectionValue: function (itemID) {
		return this.aOptionList[itemID];
	},
	HideWhichTocItems: function () {
		var key, bookitem, topicitem, myDoc = top.TOC.document;
		for (key in this.aOptionList) {
			if (this.aOptionList.hasOwnProperty(key)) {
				if (this.aOptionList[key].split('_')[0] === 'false') {
					// the li that can contain a book or a topic
					bookitem = 'listitem' + this.aOptionList[key].split('_')[1];
					// the ul containing the listitems underneath the book
					topicitem = 's' + bookitem;
					if (myDoc.getElementById(bookitem)) {
					myDoc.getElementById(bookitem).style.display = 'none';
					}
					if (myDoc.getElementById(topicitem)) {
					myDoc.getElementById(topicitem).style.display = 'none';
					}
				}
			}
		}
	},
	ShowWhichTocItems: function () {
		var key, bookitem, topicitem, myDoc = top.TOC.document;
		for (key in this.aOptionList) {
			if (this.aOptionList.hasOwnProperty(key)) {
				if (this.aOptionList[key].split('_')[0] === 'true') {
					// the li that can contain a book or a topic
					bookitem = 'listitem' + this.aOptionList[key].split('_')[1];
						// the ul containing the listitems underneath the book
						topicitem = 's' + bookitem;
					if (myDoc.getElementById(bookitem)){
						myDoc.getElementById(bookitem).style.display = '';
						}
					if (myDoc.getElementById(topicitem)){
						myDoc.getElementById(topicitem).style.display = '';
					}
				}
			}
		}
	},
	createConsolidatedCookie: function () {
		createCookie("ORA_PCUSTOM_DOC_1111", createDelimitedStringFromArray(this.aOptionList,'|'), 365);
	},
	ReadConsolidatedCookie: function (item) {
		var ConsolidatedCookie, key, conItems, i;
		key='';
		ConsolidatedCookie = readCookie("ORA_PCUSTOM_DOC_1111");
		// make sure that the ConsolidatedCookie has been set
		if ((ConsolidatedCookie !== undefined) && (ConsolidatedCookie!== null)) {
			if (item !== undefined) {
				conItems = ConsolidatedCookie.split('|');
				if (conItems !== undefined) {
					for(i=0;i < conItems.length;i++) {
						key = conItems[i].split(':')[0];
						if(key === item){
						return conItems[i].split(':')[1];
						}
					}
				}
			}	
		}
	}
};



function createDelimitedStringFromArray(arrayObject, separator) {
	var resultOut, i;
	resultOut = '';
	// make sure arrayObject is an array
	if (Object.prototype.toString.call(arrayObject) === '[object Array]') {
		for (i in arrayObject) {
			if (arrayObject.hasOwnProperty(i)) {
				resultOut +=  i +":" + arrayObject[i] + separator;
			}
		}
	return resultOut.substring(0, resultOut.length-1);
	}
}




function resetForm2(buttonGroup, setItemIDstoTrue) {
	var maxButtons = buttonGroup.length, myID, i, y, myButton, maxSetItemIDstoTrue = setItemIDstoTrue.length;
	for (i = 0; i < maxButtons; i++) {
		myID = buttonGroup[i].id;
		myButton = buttonGroup[i];
		if ((myButton !== undefined) && (myButton.checked === true)) {
			myButton.checked = false;
		}
		if ((myButton !== undefined) &&  (setItemIDstoTrue !== undefined)) {
			for (y = 0; y < maxSetItemIDstoTrue; y++) {
				if ((myButton !== undefined) && (myID === setItemIDstoTrue[y])) {
					myButton.checked = true;
				}
			}
		}
	if ((myButton !== undefined) && (myID.match(/^(group)_([A-Za-z0-9]*)/))){
			processItem(myID);
		}
	}
}



function countGroupItemsSelected(parentID, childDivID) {
var myDoc = document, parentInputTagStatus, childrenInputTags, maxChildrenInputTags, i, anyCheckedStatus;
parentInputTagStatus=myDoc.getElementById(parentID).checked;
childrenInputTags=myDoc.getElementById(childDivID).getElementsByTagName('input');
maxChildrenInputTags=childrenInputTags.length;
anyCheckedStatus = "false";
	if ((myDoc !== undefined) && (parentInputTagStatus !== undefined) && (childrenInputTags !== undefined)) {
		for (i = 0; i < maxChildrenInputTags; ++i) {
			if (myDoc.getElementById(childrenInputTags[i].id).checked === true) {
				anyCheckedStatus = "true";
			}
		}
		if (anyCheckedStatus === "false") {
		myDoc.getElementById(parentID).checked = false;
		}
		if (anyCheckedStatus === "true") {
		myDoc.getElementById(parentID).checked = true;
		}
	}

}


function collapseChild(nameoftag, classtocollapse) {
	var items, maxItems, i, myDoc = document;
	if ((myDoc !== undefined) && (nameoftag !== undefined) && (classtocollapse !== undefined)) {
		items = myDoc.getElementsByTagName(nameoftag);
		maxItems = items.length;
		if (items !== undefined) {
			for (i = 0; i < maxItems; ++i) {
				if (items[i].className === "collapsedchildnode") {
					items[i].style.display = 'none';
				}
			}
		}
	}
}
function processItem(parentID) {
	var myDoc = document;
	
	// handle non applicable choices
	// group_|53157|53158
	// group_|53164|53165
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_|53157|53158")) {
		// Non Applicable has been checked
		
		// need to set all of the installation items to false
		myDoc.getElementById('appOption_53159').checked = false;
		myDoc.getElementById('appOption_53160').checked = false;

		// need to set all of the upgrade items to false
		myDoc.getElementById('appOption_53161').checked = false;
		myDoc.getElementById('appOption_53162').checked = false;
		
		// hide the other options:
		myDoc.getElementById('53157').style.display = 'none';
		myDoc.getElementById('53158').style.display = 'none';
		
	}
	
		if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_|53164|53165")) {
		// Non Applicable has been checked
		
		// need to set all of the weblogic items to false
		
		myDoc.getElementById('appOption_53168').checked = false;
		// 531812 related to progress reporter
		// myDoc.getElementById('appOption_53182').checked = false;
		myDoc.getElementById('appOption_53195').checked = false;
		myDoc.getElementById('appOption_53196').checked = false;
		myDoc.getElementById('appOption_53198').checked = false;

		// need to set all of the websphere items to false
		myDoc.getElementById('appOption_53265').checked = false;
		// 53264 is related to progress reporter which is not avail with all releases
		// if (myDoc.getElementById(('appOption_53264') !== undefined) && myDoc.getElementById('appOption_53264')) {
			//myDoc.getElementById('appOption_53264').checked = false;
		//}
		myDoc.getElementById('appOption_53267').checked = false;
		myDoc.getElementById('appOption_53263').checked = false;
		myDoc.getElementById('appOption_53266').checked = false;
		
		// hide the other options:
		myDoc.getElementById('53164').style.display = 'none';
		myDoc.getElementById('53165').style.display = 'none';
		
		
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_53157")) {
		myDoc.getElementById('53157').style.display = 'none';
		myDoc.getElementById('appOption_53159').checked = false;
		myDoc.getElementById('appOption_53160').checked = false;

	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_53157")) {
		// Manual Database Installation has been checked
		// Hide Upgrade in the form
		myDoc.getElementById('53157').style.display = '';
		myDoc.getElementById('53158').style.display = 'none';
		// need to set all of the upgrade items to false
		myDoc.getElementById('appOption_53161').checked = false;
		myDoc.getElementById('appOption_53162').checked = false;
		if (myDoc.getElementById('appOption_53159').checked === false) {
			// 53159  is MS SQL Server.
			// 53160 is Oracle. 
			myDoc.getElementById('appOption_53160').checked = true;
		}
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_53158")) {
		myDoc.getElementById('53158').style.display = 'none';
		myDoc.getElementById('appOption_53161').checked = false;
		myDoc.getElementById('appOption_53162').checked = false;
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_53158")) {
		// Manual Database Upgrade has been checked
		// Hide  Installation in the form
		myDoc.getElementById('53158').style.display = '';
		myDoc.getElementById('53157').style.display = 'none';
		// need to set all of the installation items to false
		myDoc.getElementById('appOption_53159').checked = false;
		myDoc.getElementById('appOption_53160').checked = false;
		if (myDoc.getElementById('appOption_53161').checked === false) {
			// 53161  is MS SQL Server.
			// 53162 is Oracle. 
			myDoc.getElementById('appOption_53162').checked = true;
		}
	}
	/* **************************************************************/
	//WebLogic: 53164
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_53164")) {
		// need to make sure the items underneath are not checked
		// may want to save selection so we can restore it. 
		// the following selections are associated with WebLogic
		myDoc.getElementById('appOption_53168').checked = false;
		// 53182 is related to progress reporter
		// myDoc.getElementById('appOption_53182').checked = false;
		myDoc.getElementById('appOption_53195').checked = false;
		myDoc.getElementById('appOption_53196').checked = false;
		myDoc.getElementById('appOption_53198').checked = false;
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_53164")) {
		myDoc.getElementById('53164').style.display = '';
		myDoc.getElementById('53165').style.display = 'none';
		// may want to save selection so we can restore it. 
		// the following selections are associated with WebSphere
		// and should be turned off as we are displaying only WebLogic
		myDoc.getElementById('appOption_53265').checked = false;
		
		
		// 53264 is related to progress reporter which is not avail with all releases
		//if (myDoc.getElementById(('appOption_53264') !== undefined) && myDoc.getElementById('appOption_53264')) {
			//myDoc.getElementById('appOption_53264').checked = false;
		//}
		myDoc.getElementById('appOption_53267').checked = false;
		myDoc.getElementById('appOption_53263').checked = false;
		myDoc.getElementById('appOption_53266').checked = false;
				
		// turn on P6 in WebLogic by default (appOption_53168)
		myDoc.getElementById('appOption_53168').checked = true;
		
	}
	// WebSphere: 53165
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_53165")) {
		// need to make sure the items underneath are not checked
		// may want to save selection so we can restore it. 
		// the following selections are associated with WebSphere
		myDoc.getElementById('appOption_53265').checked = false;
		
		// 53264 is related to progress reporter which is not avail with all releases
		//if (myDoc.getElementById(('appOption_53264') !== undefined) && myDoc.getElementById('appOption_53264')) {
			//myDoc.getElementById('appOption_53264').checked = false;
		//}
		myDoc.getElementById('appOption_53267').checked = false;
		myDoc.getElementById('appOption_53263').checked = false;
		myDoc.getElementById('appOption_53266').checked = false;
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_53165")) {
		myDoc.getElementById('53165').style.display = '';
		myDoc.getElementById('53164').style.display = 'none';
		// the following selections are associated with WebLogic
		// and should be turned off as we are displaying only Websphere
		myDoc.getElementById('appOption_53168').checked = false;
		// 53182 related to progress reporter
		// myDoc.getElementById('appOption_53182').checked = false;
		myDoc.getElementById('appOption_53195').checked = false;
		myDoc.getElementById('appOption_53196').checked = false;
		myDoc.getElementById('appOption_53198').checked = false;
				
		// turn on P6 in websphere by default (appOption_53265)
		myDoc.getElementById('appOption_53265').checked = true;
		
	}
	/* **************************************************************/
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_BPM")) {
		// need to make sure the items underneath are not checked
		// may want to save selection so we can restore it.  For now we default to 12c
		//   53204 is 10G, which was deleted in 8.3 
		if (myDoc.getElementById('appOption_53206') !== undefined) {
			myDoc.getElementById('appOption_53206').checked = false;
		}
		if (myDoc.getElementById('appOption_89739') !== undefined) {
		myDoc.getElementById('appOption_89739').checked = false;
		}		
		if (myDoc.getElementById('BPM') !== undefined) {
		myDoc.getElementById('BPM').style.display = 'none';
		}
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_BPM")) {
		if (myDoc.getElementById('BPM') !== undefined) {
			myDoc.getElementById('BPM').style.display = '';
			//   53204 is 10G. 
		}
		if (myDoc.getElementById('appOption_89739') !== undefined) {
			if (myDoc.getElementById('appOption_89739').checked === false) {
			// 53206 is 11G. 
				if (myDoc.getElementById(('appOption_53206') !== undefined) && myDoc.getElementById('appOption_53206')) {
				myDoc.getElementById('appOption_53206').checked = true;
				}
			}
		}
		if (myDoc.getElementById('appOption_53206') !== undefined) {
			if (myDoc.getElementById('appOption_53206').checked === false) {
			// 89739 is 12C. 
				if (myDoc.getElementById(('appOption_89739') !== undefined) && myDoc.getElementById('appOption_89739')) {
				myDoc.getElementById('appOption_89739').checked = true;
				}
			}
		}
		// set 89739 12C to true by default
		if ((myDoc.getElementById('appOption_53206')) && (myDoc.getElementById('appOption_89739'))) {
			if ((myDoc.getElementById('appOption_53206').checked === false) && (myDoc.getElementById('appOption_89739').checked === false)) {
				myDoc.getElementById('appOption_89739').checked = true;
			}
		}
		
	}
	

	
	
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === true) && (parentID === "group_OIM")) {
		myDoc.getElementById('OIM').style.display = '';
		if (myDoc.getElementById('appOption_53111').checked === false) {
			// 53111 is 10G.  
			// 53112 is 11G.  
			myDoc.getElementById('appOption_53112').checked = true;
		}
	}
	if ((myDoc !== undefined) && (myDoc.getElementById(parentID).checked === false) && (parentID === "group_OIM")) {
		// need to make sure the items underneath are not checked
		// may want to save selection so we can restore it.  For now we default to 11g
		myDoc.getElementById('appOption_53111').checked = false;
		myDoc.getElementById('appOption_53112').checked = false;
		myDoc.getElementById('OIM').style.display = 'none';
	}
}


function setSplashPageDefaults() {
// function should be called from the onload event of the splash page
	var bodyDoc, maxListItems, i, myOption, listItems, mytopiclistitem, topDoc, IndexNum, framesetPath, framesetFileName;
	bodyDoc=top.BODY.document;
	topDoc=top.document; // new var
	if (bodyDoc){
		listItems=bodyDoc.getElementsByTagName("li");
	}
	if (topDoc !== undefined) {
		framesetPath = topDoc.location.href;
		// test to make sure that the top document is helpmaincustom.htm
		IndexNum=framesetPath.lastIndexOf('/');
		// alert("my lngIndex from open_parent.js: " + lngIndex);
		if (IndexNum > -1) {
			framesetFileName = framesetPath.slice(IndexNum+1);
			} else {
			framesetFileName = framesetPath;
		}
	}
	if ((listItems !== undefined) && (framesetFileName !== undefined) && (framesetFileName === 'helpmaincustom.htm')) {
	maxListItems=listItems.length;
		for (i= 0; i < maxListItems; i++){
			if (listItems[i].id && listItems[i].id.match(/^(topiclistitem)([0-9]*)/)){
			myOption = oOptions.ReadConsolidatedCookie("appOption_"+RegExp.$2);
				if ((myOption !== undefined) && (myOption !== null) ){
					if ((myOption.split('_')[0] === 'false') && (myOption.split('_')[1])){
						mytopiclistitem = "topiclistitem" + myOption.split('_')[1];
						if (bodyDoc.getElementById(mytopiclistitem)){
							bodyDoc.getElementById(mytopiclistitem).style.display = 'none';
						}
					}
					if ((myOption.split('_')[0] === 'true') && (myOption.split('_')[1])){
						mytopiclistitem = "topiclistitem" + myOption.split('_')[1];
						if (bodyDoc.getElementById(mytopiclistitem)){
							bodyDoc.getElementById(mytopiclistitem).style.display = '';
						}
					}
				}
			}
		}
	}
}

function setFormDefaults(buttonGroup) {
	var installationOpCounter, applicationOPCounter, maxButtonGroup, myOption, myID, i;
	installationOpCounter = 0;
	applicationOPCounter= 0;
	maxButtonGroup=buttonGroup.length;
	for (i= 0; i < maxButtonGroup; i++) {
	myOption = oOptions.ReadConsolidatedCookie(buttonGroup[i].id);
	myID = buttonGroup[i].id;
		if (buttonGroup[i].id && buttonGroup[i].id.match(/^(group|app|installation)Option_([0-9]*)/)) {												 
			if (RegExp.$1 === "installation") {
				// to use this in IE, uncomment the console, then F12, then go to the script tab
				// console.log("process(install): id=%s, number=%s", buttonGroup[i].id,  RegExp.$2);
				if (myOption !== undefined){
					// console.log("State: '%s'", mydataInstall.CheckedValue);
					if (myOption.split('_')[0] === 'false') {
						document.getElementById(myID).checked = false;
					}
					if (myOption.split('_')[0] === 'true') {
						document.getElementById(myID).checked = true;
					}
				installationOpCounter +=1;	
				}
			} else {
				// console.log("process(app): id=%s, number=%s", buttonGroup[i].id,  RegExp.$2);
				if (myOption !== undefined) {
					if (myOption.split('_')[0] === 'false') {
						document.getElementById(myID).checked = false;
					}
					if (myOption.split('_')[0] === 'true') {
						document.getElementById(myID).checked = true;
					}
					applicationOPCounter +=1;
				}
			}
		}
		if (buttonGroup[i].id && buttonGroup[i].id.match(/^(group)_([A-Za-z0-9]*)/)){
		 	if (myOption !== undefined){
				if (myOption.split('_')[0] === 'false'){
					document.getElementById(myID).checked = false;
				}
				if (myOption.split('_')[0] === 'true'){
					document.getElementById(myID).checked = true;
				}
			}
			processItem(myID)
		 }
	}
}


function cycle(form, defaultPage){
	var i, myTOC, myBodyDoc;
	myTOC = top.TOC;
	myBodyDoc = top.BODY;
	 if (myTOC !== undefined){
		 getSelectedItems(form.elements);
		i = getSelectedItems(form.elements);
	 } else {
	 alert("The table of contents frame is not available.");
	 }
	if (myBodyDoc !== undefined){
		if (defaultPage !== undefined) {
			if (defaultPage === '61605.htm') {
				// 61605.htm contains a list of books for the combo
				myBodyDoc.location.replace('61605.htm');
			}
			if (defaultPage === '62407.htm') {
				// 62407.htm contains a list of books for the auto
				 myBodyDoc.location.replace('62407.htm');
			}
			if (defaultPage === '55823.htm') {
				// 55823.htm contains a list of books for the 8.2 combo
				myBodyDoc.location.replace('55823.htm');
			}
			if (defaultPage === '55824.htm') {
				// 55824.htm contains a list of books for the 8.2 auto
				 myBodyDoc.location.replace('55824.htm');
			}
		} else {
			// 6706.htm is the first topic of the preface.
			 myBodyDoc.location.replace('6706.htm');
		}
	}
}

function getSelectedItems(buttonGroup) {
	var i, maxButtonGroupItems;
	maxButtonGroupItems = buttonGroup.length;
		for (i= 0; i < maxButtonGroupItems; i++) {
			if (buttonGroup[i].checked) {
				oOptions.saveselection(buttonGroup[i].id, 'true_' + buttonGroup[i].value);
			 } else {
				oOptions.saveselection(buttonGroup[i].id, 'false_' + buttonGroup[i].value);
			}
		}
	oOptions.HideWhichTocItems();
	oOptions.ShowWhichTocItems();
	oOptions.createConsolidatedCookie();
	return 0;
}



function createCookie(name,value,days) {
	var date, expires;
	if (days) {
		date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		expires = "; expires="+date.toGMTString();
	} else {
	expires = "";
	}
	document.cookie = name+"="+value+expires+"; path=/";
}



function readCookie(name) {
	var i, c, nameEQ, ca;
	nameEQ = name + "=";
	ca = document.cookie.split(';');
	for(i=0;i < ca.length;i++) {
		c = ca[i];
		while (c.charAt(0)===' ') {
		c = c.substring(1,c.length);
		}
		if (c.indexOf(nameEQ) === 0) {
		return c.substring(nameEQ.length,c.length);
		}
	}
	return null;
}


