﻿
// Functions for Custom TOC

function displayForm(whichForm) {
var myDoc, myTopDoc, formToDisplay;
	 myDoc=top.TOC.document;
	 myTopDoc=top.document;
	if (whichForm !== undefined) 
	{
		if  (whichForm === 'auto') 
		{ 
			formToDisplay = "automatic.htm";
		} else if  (whichForm === 'combo') 
		{ 
			formToDisplay = "combo.htm";
		} else 
		{
		alert("The form is not available");
		}
	}
// iframecustomtoc
	if (myDoc != undefined && formToDisplay !== undefined ) 
	{
		// myDoc.getElementById('divcustomtoc').style.display='block';
		// myDoc.getElementById('divcustomtoc').style.visibility='visible';  // added to address an issue with IE 7
		// myDoc.getElementById('divcustomtoc').style.position='absolute';
		// myDoc.getElementById('divcustomtoc').style.top='0';

		myDoc.getElementById('divcustomtoc').style.display='block';
		myDoc.getElementById('divcustomtoc').style.visibility='visible';  // added to address an issue with IE 7
		
		myDoc.getElementById('maintocdiv').style.display='none';
		myDoc.getElementById('maintocdiv').style.visibility='hidden';  // added to address an issue with IE 7
		myDoc.getElementById('iframecustomtoc').src=formToDisplay;
	}
	if (myTopDoc !== undefined && formToDisplay !== undefined )
	{
		myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="100%";
		myTopDoc.getElementById('NAV_FRAMESET').rows="*,100%";  // rows="22,*" 
		myTopDoc.getElementById('TOC').scrolling="no";
		myTopDoc.getElementById('TOC').resize="noresize";  // need to set this back to resize in the submit code for the form if search is desired.
		myTopDoc.getElementById('BODY').scrolling="no";
	}
}


function DisplayTocTab(tabname, ShowHide) {
// switches the tab to toc and displays the toc.htm file in the toc frame
// optionally calls  ShowHideContents(ShowHide)
// hides, shows, or toggles the contents frame 
var myTabDoc,myTocDoc;
	myTabDoc=top.TAB.document;
	myTocDoc=top.TOC.document;
	
	if ((myTabDoc !== undefined) && (myTocDoc !== undefined))
	{
		var thehref = myTocDoc.location.href.slice(myTocDoc.location.href.lastIndexOf('/')+1);
		tabname = 'tab_' + tabname +'_no_index' + '.htm'
		if (myTabDoc.location.href.indexOf(tabname) === -1)
		{
			myTabDoc.location.replace(tabname);
		}
		if ((thehref != 'toc.htm') && (tabname === 'tab_toc_no_index.htm')) 
		{
			myTocDoc.location.replace('toc.htm');
		}
		if (ShowHide !== undefined) {
			ShowHideContents(ShowHide)
		}
	}
}

// create function property variables
// var not used here
// display is used by UAP function
ShowHideContents.display = "initial";
function ShowHideContents(ShowHide) {
// hides, shows, or toggles the contents frame
// ShowHide = 'hide' 'show' or 'toggle'
	var myTopDoc=top.document;
	if ((myTopDoc != undefined) && (myTopDoc.getElementById('NAV_CONTENT_FRAMESET')) && (myTopDoc.getElementById('BODY'))) {
		if ((ShowHide) && (ShowHide == 'hide')) {
				myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="*,100%";
				myTopDoc.getElementById('BODY').style.borderLeft = '0px none #557799';
				
				ShowHideContents.display='hidden';

		} else if ((ShowHide) && (ShowHide == 'show')) {
			myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="25%,*";
			myTopDoc.getElementById('BODY').style.borderLeft = '1px solid #557799';
			
			ShowHideContents.display='shown';
			
		} else if ((ShowHide) && (ShowHide == 'toggle')) {
			if ( myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols=="*,100%") {
				myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="25%,*";
				myTopDoc.getElementById('BODY').style.borderLeft = '1px solid #557799';
				
				ShowHideContents.display='shown';
				
			} else {
				myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="*,100%";
				myTopDoc.getElementById('BODY').style.borderLeft = '0px none #557799';
				
				ShowHideContents.display='hidden';
				
			}
		}
	}
}



function displayToc() {
	var myDoc=top.TOC.document;
	var myTopDoc=top.document;
	if ((myDoc != undefined) && (myTopDoc != undefined)) 
	{ 
		myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="*,100%";
		collapseAllBooks(); // workaround to resolve issue of child items 
		// not retaining their indent after the custom book form is submitted
		myDoc.getElementById('divcustomtoc').style.display='none';
		myDoc.getElementById('divcustomtoc').style.visibility='hidden';  // added to address an issue with IE 7
		
		myDoc.getElementById('maintocdiv').style.display='block';
		myDoc.getElementById('maintocdiv').style.visibility='visible';  // added to address an issue with IE 7

		myTopDoc.getElementById('NAV_CONTENT_FRAMESET').cols="25%,*";
		myTopDoc.getElementById('TOC').scrolling="auto";
		myTopDoc.getElementById('BODY').scrolling="auto";
	}
}

// Functions for TOC

function book() {
// var theBook=top.TOC.document.getElementById('b'+id);
// for now this function does nothing.
// 
// if (theBook != undefined)
	//{
	// alert(myBook);
	// } else {
	// alert(id);
	// }
//	}
}

function exp(id) {

	var myDoc=top.TOC.document;
	if (myDoc != undefined) 
	{
		var myBookTopicList=myDoc.getElementById('s'+id); // a ul containing a book
		var myImage=myDoc.getElementById('p'+id); // image that contains minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
		var myBook=myDoc.getElementById('b'+id); // obook.gif or cbook.gif
	}
		if (myImage.src != undefined) {
			if (typeof myImage.src=="string") {
				var myImageSrc=myImage.src.slice(myImage.src.lastIndexOf('/')+1);  // minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
			}
		} else {
		// the id that is passed to us does not exist with a p prefix
		}
  	if ( (myBook != undefined) && (myBookTopicList != undefined) && (myDoc != undefined) && (myImageSrc != undefined) )
	{
		if (myImageSrc == 'minus.gif') {
		    // collapse(id); // original
			myBookTopicList.style.display='none'; 
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			
			myBook.src='cbook.gif';
			myImage.src='plus.gif';
			myImage.alt="Expand";
			
		} else if (myImageSrc == 'minus_highcontrast.gif') {
			// collapseHighContrast(id) // call new function
			myBookTopicList.style.display='none';
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			myBook.src='cbook.gif';
			myImage.src='plus_highcontrast.gif';  // Supports high contrast style sheet
			myImage.alt="Expand";
		} else if (myImageSrc == 'plus_highcontrast.gif') {
			// expandHighcontrast(id) // call new function
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus_highcontrast.gif'; 
			myImage.alt="Collapse";
		} else if  (myImageSrc == 'plus.gif') { 
			// expand(id); // original 
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus.gif';
			myImage.alt="Collapse";
		} else{
			//  the id does not exist, we are not in the toc frame, or some other issue
		}
		
	}
}


function expand(id) {
	var myDoc, myBookTopicList, myImage, myBook, myImageSrc;
  	 myDoc=top.TOC.document;
	if (myDoc !== undefined) 
	{
		myBookTopicList=myDoc.getElementById('s'+id); // a ul containing a book
		myImage=myDoc.getElementById('p'+id); // image that contains minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
		myBook=myDoc.getElementById('b'+id); // obook.gif or cbook.gif
	}
	
	if ( ( myImage !== null ) && (myImage.src !== undefined) && (typeof myImage.src === "string") ) {
		myImageSrc=myImage.src.slice(myImage.src.lastIndexOf('/')+1);  // minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
	}
  	if ( (myBook !== undefined) && (myBookTopicList !== undefined) && (myDoc !== undefined) && (myImageSrc !== undefined) )
	{
		if (myImageSrc === 'minus.gif') {
			// expand 
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus.gif';
			myImage.alt="Collapse";
			
		} else if (myImageSrc === 'minus_highcontrast.gif') {
			// expand
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus_highcontrast.gif'; 
			myImage.alt="Collapse";
			
		} else if (myImageSrc === 'plus_highcontrast.gif') {
			// expandHighcontrast
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus_highcontrast.gif'; 
			myImage.alt="Collapse";
		} else if  (myImageSrc === 'plus.gif') { 
			// expand
			myBookTopicList.style.display='block';
			myBookTopicList.style.visibility='visible';  // added to address an issue with IE 7
			myBook.src='obook.gif';
			myImage.src='minus.gif';
			myImage.alt="Collapse";
		} else{
		//  the id does not exist, we are not in the toc frame, or some other issue
		}
		
	}
}


function collapse(id) {
	var myDoc, myBookTopicList, myImage, myBook;
	 myDoc=top.TOC.document;
	if (myDoc !== undefined) 
	{
		myBookTopicList=myDoc.getElementById('s'+id); // a ul containing a book
		myImage=myDoc.getElementById('p'+id); // image that contains minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
		myBook=myDoc.getElementById('b'+id); // obook.gif or cbook.gif
	}
	
	// myImage could be null if pattern of book, topic, book
	if ( ( myImage !== null ) && (myImage.src !== undefined) && (typeof myImage.src === "string") ) {
		var myImageSrc=myImage.src.slice(myImage.src.lastIndexOf('/')+1);  // minus.gif, plus.gif, minus_highcontrast.gif, plus_highcontrast.gif
	}
	
  	if ( (myBook !== undefined) && (myBookTopicList !== undefined) && (myDoc !== undefined) && (myImageSrc !== undefined) )
	{
		if (myImageSrc === 'minus.gif') {
		    // collapse
			myBookTopicList.style.display='none'; 
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			myBook.src='cbook.gif';
			myImage.src='plus.gif';
			myImage.alt="Expand";
			
		} else if (myImageSrc === 'minus_highcontrast.gif') {
			// collapseHighContrast
			myBookTopicList.style.display='none'; 
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			myBook.src='cbook.gif';
			myImage.src='plus_highcontrast.gif';  // Supports high contrast style sheet
			myImage.alt="Expand";
		} else if (myImageSrc === 'plus_highcontrast.gif') {
			// collapseHighContrast
			myBookTopicList.style.display='none'; 
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			myBook.src='cbook.gif';
			myImage.src='plus_highcontrast.gif';  // Supports high contrast style sheet
			myImage.alt="Expand";
		} else if  (myImageSrc === 'plus.gif') { 
		    // collapse
			myBookTopicList.style.display='none'; 
			myBookTopicList.style.visibility='hidden';  // added to address an issue with IE 7
			myBook.src='cbook.gif';
			myImage.src='plus.gif';
			myImage.alt="Expand";
		} else{
			//  the id does not exist, we are not in the toc frame, or some other issue
		}
		
	}
}


function collapseAllBooks() {
var myDoc, items, maxItems;
	myDoc=top.TOC.document;
	if (myDoc !== undefined) 
	{
		items = myDoc.getElementsByTagName("ul");
		maxItems = items.length;
		if (items !== undefined) {
			for (var i = 0; i < maxItems; ++i)
			{
				if (items[i].id !== undefined && items[i].id !== "ultoc") 
				{
				// use substr to get rid of the s prefix
				// may want to add a test to make sure that the first character is an s followed by a number.
				// this test could be used instead of the test for ultoc
				collapse(items[i].id.substr(1))
				}
			}
		}
	}
}

function expandAllBooks() {
var myDoc, items, maxItems;
	myDoc=top.TOC.document;
	if (myDoc !== undefined) 
	{
		items = myDoc.getElementsByTagName("ul");
		maxItems = items.length;
		if (items !== undefined) {
			for (var i = 0; i < maxItems; ++i)
			{
				if (items[i].id !== undefined && items[i].id !== "ultoc") 
				{
				// use substr to get rid of the s prefix
				expand(items[i].id.substr(1))
				}
			}
		}
	}
}
function highlight(id) {
	var myDoc, myAnchor, myItem, liElements, aElements, maxliItems, maxaItems, myContrastSetting, myListItem, myAnchorItem, i;
	myDoc = top.TOC.document;
	myAnchor = myDoc.getElementById('a' + id);
	myItem = myDoc.getElementById('listitem' + id); // getElementById returns null if element does not exist
	liElements = myDoc.getElementsByTagName("li");
	aElements = myDoc.getElementsByTagName("a");
	maxliItems = liElements.length;
	maxaItems = aElements.length;
	if (typeof getActiveStyleSheet === 'function') {
		myContrastSetting = getActiveStyleSheet();
	} else {
		myContrastSetting = 'default';
	}
	if ((myDoc !== undefined) && (liElements !== undefined) && (myAnchor !== undefined) && (aElements !== undefined) && (myItem !== undefined)) {
		// loop through all of the list items in the TOC frame and unhighlight items that are not the currently selected one
		for (i = 0; i < maxliItems; ++i) {
			myListItem = liElements[i];
			if ((myListItem.id !== undefined) && (myListItem.style !== undefined)) {
				// test for null myItem to ovoid error if it does not exist when it is compared to myListItem.id
				if ((myItem !== null) && (myItem.id !== undefined) && (myListItem.id !== myItem.id)){
					myListItem.style.background=''; // default
				} else if (myItem === null) {
					myListItem.style.background=''; // we must be on a csh topic or data dictionary set it to the default
				} 
			}
		}
		for (i = 0; i < maxaItems; ++i) {
		// loop through all of the anchor items in the TOC frame and unhighlight items that are not the currently selected one
		// note that there may be more maxaItems  than  maxliItems due to the collapse and expand links.  running separate loops to avoid any related complexity.
			myAnchorItem = aElements[i];
			if ((myAnchorItem.id !== undefined) && (myAnchorItem.style !== undefined)) {
				if  ((myItem !== null) && (myAnchorItem.id !== myItem.id)){
					myAnchorItem.style.color = '';
				} else if (myItem === null) {
					myAnchorItem.style.color = ''; // we must be on a csh topic or data dictionary
				} 
			}
		}
		// set the highlight.  
		// **********************
		// highlight the item that we are on.
		// highlight the text in the anchor accounting for the contrast
		// Note CSH topics are not necessarily in the TOC and therefore may not have an object with style property that matches (myItem will be null)
		if ((myContrastSetting !== undefined) && (myContrastSetting === 'contrast')) {
			if (myItem !== null){
				if (myItem.style !== undefined) {
					myItem.style.background = '#50729f'; 
					}
				if (myAnchor.style !== undefined) {
					myAnchor.style.color = '#ffff00'; 
				}
			}
		} else { 
			if (myItem !== null) {
				if (myItem.style !== undefined) { 
					myItem.style.background = '#043668'; 
					}
				if (myAnchor.style !== undefined){ 
				myAnchor.style.color = '#ffffff'; 
				}
			}  
		}
 	}
}
function loadTOC() {
  // check current page displayed in TOC window.  If not toc.htm, load it.
  if (!isTOCLoaded()) {
    top.TOC.location.href = 'toc.htm';
  }
}

function isTOCLoaded() {
  // return true, if toc.htm is loaded in TOC window.
  if (top.TOC) {
	var myPath, myFile;
    myPath = top.TOC.location.pathname;
    myFile = myPath.substr(myPath.length - 7);

    if (myFile === 'toc.htm') {
      return true;
    } else {
      return false; 
    }
  } else {
    return false;
  }
}

